import {
	request
} from '../utils/request'

// 获取验证码
export function getCodeImg() {
	return request({
		url: '/wechat/captchaImage',
		method: 'get',
	})
}

// 用户登录
export function login(data) {
	return request({
		url: '/wechat/login',
		method: 'post',
		data: data,
	})
}

// 修改密码
export function updatePwd(data) {
	return request({
		url: '/wechat/v1/updatePassword',
		method: 'post',
		data: data,
	})
}

// 修改密码
export function codeUpdatePwd(data) {
	return request({
		url: '/wechat/v1/codeUpdatePwd',
		method: 'post',
		data: data,
	})
}

// 用户退出方法
export function loginOut() {
	return request({
		'url': '/wechat/loginOut',
		'method': 'get'
	})
}

// 发送短信验证码
export function sendPhoneMessage(phoneNumber) {
	return request({
		url: '/wechat/v1/sendPhoneMessage',
		method: 'post',
		data: {
			'phoneNumber': phoneNumber
		}
	})
}

// 查询公众号消息授权
export function findOpenUserMsgId(openId) {
	return request({
		'url': '/wechat/findOpenUserMsgId/' + openId,
		'method': 'get'
	})
}

// 删除公众号消息授权
export function delOpenUserMsgId(openId) {
	return request({
		'url': '/wechat/delOpenUserMsgId/' + openId,
		'method': 'get'
	})
}