import {
    groupUserByParams,
    attendanceUserList
} from '../../../../api/projectAttendance'
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        type: "1",
        initData: {},
        projectId: "",
        companyTypeId: "101",
        listData: [],
        pageNum: 1,
        pageSize: 50,
        lastDataSize: 50,
        list: [],
        request: app.globalData.reqUrl,
        nactive: 0,
        labourTypeList: [{
            name: "总包人员",
            total: 0,
        }, {
            name: "监理人员",
            total: 0,
        }, {
            name: "劳务人员",
            total: 0,
        }],
        search: "",
        choiceShow: false
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        let {
            type
        } = options
        this.setData({
            type,
            typeName: type == "1" ? "在岗" : "离岗",
            projectId: app.globalData.projectId,
            initData: {
                text: app.globalData.projectName,
                id: app.globalData.projectId
            },
            search: "",
            pageNum: 1,
            pageSize: 50,
            lastDataSize: 50,
            listData: []
        })
        this.getListData();
    },

    // 事件委托
    selected(e) {
        let nav = e.target.dataset.set;
        let companyTypeId = "";
        if (nav == 0) {
            companyTypeId = "101";
        } else if (nav == 1) {
            companyTypeId = "102";
        } else {
            companyTypeId = "103";
        }
        this.setData({
            pageNum: 1,
            pageSize: 50,
            lastDataSize: 50,
            listData: [],
            companyTypeId,
            nactive: nav
        })
        this.getListData();
    },

    /**
     * 条件筛选
     * @param {*} options 
     */
    onInputSearch: function (options) {
        this.setData({
            search: options.detail.value,
        })
    },

    onQueryData: function(){
        this.setData({
            pageNum: 1,
            pageSize: 50,
            lastDataSize: 50,
            listData: []
        })
        this.setData({
            choiceShow:false
        })
        this.getListData();
    },

    /**
     * 查看人员详情
     */
    getInfo(e) {
        let {
            id
        } = e.currentTarget.dataset.set
        wx.redirectTo({
            url: `../info/index?id=${id}`
        })
    },

    /**
     * 查询项目质量隐患排查数据
     */
    getListData() {
        //进入这里说明数据加载完毕
        if (this.data.lastDataSize < this.data.pageSize) {
            //app.toast("已经到底了，暂无可继续加载数据!")
            return;
        }
        let params = {
            "companyTypeId": this.data.companyTypeId,
            "projectId": this.data.projectId,
            "state": this.data.type == "1" ? 0 : 1,
            pageNum: this.data.pageNum,
            pageSize: this.data.pageSize,
            name: this.data.search
        }
        this.initGroupAllByParams();
        var that = this;
        attendanceUserList(params).then(res => {
            //这里处理this.data.lastDataSize=this.data.pageSize
            if (that.data.list.length > 0 && res.rows.length > 0 && that.data.list[0].id == res.rows[0].id) {
                that.setData({
                    lastDataSize: 0,
                })
            } else {
                that.setData({
                    pageNum: that.data.pageNum + 1,
                    lastDataSize: res.rows.length,
                    list: res.rows,
                    listData: that.data.listData.concat(res.rows)
                })
            }
        });
    },

    /**
     * 初始化考勤信息
     */
    initGroupAllByParams() {
        let zb = 0;
        let jl = 0;
        let lw = 0;
        groupUserByParams({
            projectId: app.globalData.projectId,
            name: this.data.search
        }).then(res => {
            if (res.data.length > 0) {
                res.data.forEach(item => {
                    if (item.type == this.data.type) {
                        if (item.companyTypeId == 8) {
                            jl += item.total;
                        } else if (item.companyTypeId == 1 || item.companyTypeId == 6) {
                            zb += item.total;
                        } else {
                            lw += item.total;
                        }
                    }
                });
            }
            this.setData({
                "labourTypeList[0].total": zb,
                "labourTypeList[1].total": jl,
                "labourTypeList[2].total": lw,
            })
        });
    },

    returnToPage: function () {
        wx.redirectTo({
            url: '../../../../pages/xiangmugaikuang/index',
        })
    },

    //项目切换 返回值
    onProjectSelect(e) {
        let projectId = e.detail.id;
        let projectName = e.detail.text;
        app.globalData.projectId = projectId;
        app.globalData.projectName = projectName;
        this.onLoad({});
    },

    onScrollToLower() {
        console.log("滚动条到底了，开始加载新数据");
        this.getListData();
    },

    choice() {
        this.setData({
            choiceShow: true
        });
    },
    onCloseTest() {
        this.setData({
            choiceShow: false
        });
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide() {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload() {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage() {

    }
})